/****************************************************************************
** Form interface generated from reading ui file 'settingsDialog.ui'
**
** Created: Tue Mar 23 15:24:42 2004
**      by: The User Interface Compiler ($Id: qt/main.cpp   3.3.2-snapshot-20040317   edited Nov 24 13:47 $)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#ifndef SETTINGSDIALOG_H
#define SETTINGSDIALOG_H

#include <qvariant.h>
#include <qdialog.h>
#include <qmemarray.h>
#include <qbutton.h>
#include <qregexp.h>
#include "cpp-core/GenomeMixer.h"
#include "cpp-core/CellData.h"
#include "autoGenMarkers.h"
#include "interferenceDialog.h"
#include "recombinationDialog.h"

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QSpacerItem;
class QLabel;
class QPushButton;
class QTabWidget;
class QWidget;
class QTable;
class QFrame;
class QGroupBox;
class QSpinBox;
class QButtonGroup;
class QCheckBox;
class QLineEdit;
class QComboBox;

class SettingsDialog : public QDialog
{
    Q_OBJECT

public:
    SettingsDialog( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~SettingsDialog();

    QLabel* textDisplayInfo;
    QPushButton* buttonDiscardChanges;
    QPushButton* buttonDone;
    QTabWidget* settingsTabWidget;
    QWidget* chrTab;
    QTable* tableSexChr;
    QTable* tableChr;
    QPushButton* buttonChrDelete;
    QPushButton* buttonChrNew;
    QFrame* frame4;
    QLabel* textNumChr;
    QGroupBox* lengthGroupBox;
    QLabel* textLenMB;
    QLabel* textCMValue;
    QLabel* textMBValue;
    QLabel* textLen_cM;
    QGroupBox* groupBox13;
    QLabel* textLabel5;
    QLabel* textRecomb;
    QLabel* textInterference;
    QPushButton* buttonChooseInterfere;
    QPushButton* buttonChooseRecomb;
    QLabel* genInfoText;
    QWidget* markerTab;
    QTable* tableMarkers;
    QPushButton* buttonMarkerDelete;
    QPushButton* buttonMarkerNew;
    QFrame* frame6;
    QGroupBox* groupBox5;
    QLabel* textLabel2;
    QPushButton* buttonMarkerAutoGen;
    QLabel* textMarkersTotal;
    QLabel* textInfoMarkersGeneral;
    QWidget* purebredsTab;
    QFrame* frame5;
    QLabel* textPurebredNum;
    QLabel* purebredText2;
    QTable* tablePurebreds;
    QPushButton* buttonPurebredDelete;
    QPushButton* buttonPurebredNew;
    QFrame* frame6_2;
    QLabel* purebredText1;
    QWidget* schemeTab;
    QLabel* textSchemeChange;
    QLabel* textSchemeCages;
    QSpinBox* spinSchemeCages;
    QLabel* textSchemeGen;
    QSpinBox* spinSchemeGenerations;
    QLabel* textLabel1;
    QTable* tableScheme;
    QButtonGroup* optionsGroup;
    QCheckBox* schemeCheckEnabled;
    QCheckBox* schemeCheckExport;
    QGroupBox* parentsGroup;
    QLineEdit* schemeParentFem;
    QComboBox* schemePulldownMale;
    QLineEdit* schemeParentMale;
    QComboBox* schemePulldownFem;
    QLabel* femaleParentLabel;
    QLabel* maleParentLabel;
    QGroupBox* progenyGroup;
    QLabel* atLeastFemale;
    QSpinBox* schemeSpinFem;
    QLabel* smallFemLabel;
    QLabel* atLeastMale;
    QSpinBox* schemeSpinMale;
    QLabel* smallMaleLabel;
    QLabel* miceRandomSex;
    QSpinBox* schemeSpinRandomSex;

    virtual bool markersChanged();
    virtual bool settingsChanged();

public slots:
    virtual void setUpSettings( GenomeMixer * theMainPtr );
    virtual void reloadEverything();
    virtual void doneButtonWasPressed();
    virtual void theCurrentTabChanged();
    virtual void renumberTable( QTable * table, int start, int finishNonInclusive );
    virtual void makeAllClean();
    virtual void makeCurrentPaneDirty();
    virtual void updateSaveDiscardButtons();
    virtual void applyChanges();
    virtual void discardChanges();
    virtual void chrTableApply();
    virtual void reloadChrData();
    virtual void updateChromosomeInfo();
    virtual void chrNew();
    virtual void chrDelete();
    virtual void markersTableApply();
    virtual void reloadMarkerData();
    virtual void updateMarkerInfo();
    virtual void markerNew();
    virtual void markerDelete();
    virtual void chooseInterferenceModel();
    virtual void chooseRecombinationModel();
    virtual void markersAutoGenerate();
    virtual void purebredTableApply();
    virtual void validatePurebredItem( int row, int col );
    virtual void reloadPurebredData();
    virtual void updatePurebredInfo();
    virtual void purebredNew();
    virtual void purebredDelete();
    virtual void schemeTableApply();
    virtual void reloadSchemeData( void );
    virtual void currentCellHasChanged( int row, int col );
    virtual void updateSchemeInfo( void );
    virtual void updateSchemeInfo( int row, int col );
    virtual QString lettersFromNum( int num );
    virtual void renumberCages( QTable * table, int start, int finishNonInclusive );
    virtual void renumberGenerations( QTable * table, int start, int finishNonInclusive );
    virtual void schemeChangeNumCages( int newCages );
    virtual void schemeChangeNumGen( int newGens );
    virtual void makeCellWhenThereIsNone( int row, int col );
    virtual void schemeChangeEnabled( bool state );
    virtual void schemeChangeExport( bool state );
    virtual void cellManuallyEdited( int row, int col );
    virtual void reject( void );
    virtual void closeEvent( QCloseEvent * closer );
    virtual void spinTotalChanged( int value );
    virtual void spinFemalesChanged( int value );
    virtual void spinMalesChanged( int value );
    virtual void schemeParentPulldownFemale( int item );
    virtual void schemeParentPulldownMale( int item );
    virtual void schemeParentPulldown( int item, bool sex );
    virtual void schemeFemaleParentManualEdit();
    virtual void schemeMaleParentManualEdit();
    virtual void schemeParentBeingManuallyEdited();

protected:
    bool markersDirty;
    bool settingsDirty;
    GenomeMixer *mainMixPtr;
    bool markersChangedAtAll;
    bool settingsChangedAtAll;

    QGridLayout* SettingsDialogLayout;
    QHBoxLayout* layout27;
    QHBoxLayout* chrTabLayout;
    QVBoxLayout* layout17;
    QHBoxLayout* layout35;
    QSpacerItem* spacer13;
    QVBoxLayout* frame4Layout;
    QSpacerItem* spacer5;
    QGridLayout* lengthGroupBoxLayout;
    QSpacerItem* spacer12;
    QGridLayout* layout11;
    QGridLayout* groupBox13Layout;
    QGridLayout* layout33;
    QSpacerItem* spacer44;
    QGridLayout* layout55;
    QSpacerItem* spacer43_2;
    QGridLayout* markerTabLayout;
    QVBoxLayout* layout19;
    QHBoxLayout* layout18;
    QSpacerItem* spacer15;
    QGridLayout* frame6Layout;
    QVBoxLayout* groupBox5Layout;
    QGridLayout* purebredsTabLayout;
    QVBoxLayout* frame5Layout;
    QSpacerItem* spacer10;
    QSpacerItem* spacer17;
    QGridLayout* layout40;
    QSpacerItem* spacer16;
    QGridLayout* frame6_2Layout;
    QVBoxLayout* schemeTabLayout;
    QHBoxLayout* layout16;
    QSpacerItem* spacer18;
    QHBoxLayout* optionsGroupLayout;
    QSpacerItem* spacer8_2;
    QSpacerItem* spacer8;
    QHBoxLayout* layout13;
    QGridLayout* parentsGroupLayout;
    QGridLayout* progenyGroupLayout;
    QHBoxLayout* layout25;
    QHBoxLayout* layout26;
    QVBoxLayout* layout12;
    QSpacerItem* spacer20_2;
    QSpacerItem* spacer20;
    QHBoxLayout* layout11_2;

protected slots:
    virtual void languageChange();

private:
    void init();

};

#endif // SETTINGSDIALOG_H
